/*-
	Title:		old2new.c
	Author:		belami ()
	Description: 	.DIR   ٲٱ  α׷Դϴ.
			struct fileheader {} ʵ  ٲٴ α׷Դϴ.
	Note:		ڼ ӿ  struct filehead{}  ٸ
			ʵ   ʵ 迭 ϴµ .
	bbs.h:
	struct fileheader {             // This structure is used to hold data in //
		char filename[STRLEN] ;     // the BOARDS and DIR files               //
		char owner[STRLEN] ;
		char title[STRLEN] ;
		unsigned level;
		unsigned char accessed[MAXUSERS] ;
		unsigned char tm_year;  // struct tm  ϰ ̸ٿ //
		unsigned char tm_mon;
		unsigned char tm_mday;
		// dummy //
		unsigned char isdirectory; // .BOARDS Ͽ Ǵ ÷̰ //
					   // ̸̸ 0            //
					   // 丮 ̸̸ 1       //
		unsigned short int readcnt;// ȸ //
		unsigned char dummy[218];
	} ;

		
*/
#include <stdio.h>
#include "bbs.h.old"
main(argc, argv)
    int             argc;
    char           *argv[];
{
    char           *infname, outfname[500];
    int             oldsize;
    FILE           *inf, *outf;
    char            buf[5 * 1024];
    struct fileheader rbuf;
    char	    empty[1024];

    bzero(empty, 1024);

    if (argc == 1)
	printf("usage: %s file recordsize\n", argv[0]), exit(1);

    infname = argv[1];
    oldsize = atoi(argv[2]);

    sprintf(outfname, "%s.bak", infname);

    if ((inf = fopen(infname, "r"))) {
	if ((outf = fopen(outfname, "w"))) {
	    int             rbytes, written;
	    while (bzero(&rbuf, oldsize), oldsize == fread(&rbuf, 1, oldsize, inf)) {
		int             off1, off2, off3, size1, size2, size3;
		struct fileheader *fhp;
		off1 = 0;
		off2 = sizeof(char) * STRLEN * 3	/* filename,owner,title */
		    + sizeof(unsigned)	/* level */
		    +sizeof(unsigned char) * MAXUSERS;	/* 0 ~ accessed */
		off3 = sizeof(char) * STRLEN * 3	/* filename,owner,title */
		    + sizeof(unsigned);	/* level */

		size1 = sizeof(char) * STRLEN * 3	/* filename,owner,title */
		    + sizeof(unsigned);	/* 0 ~ level */
		size2 = sizeof(unsigned char) * 4	/* tm_year,tm_mon,tm_mday
							 * */
		    + sizeof(unsigned short int)	/* readcnt */
		    +sizeof(unsigned char) * 218;	/* tm_year ~ dummy */
		size3 = sizeof(unsigned char) * MAXUSERS;	/* accecced */

		fwrite(&rbuf, 1, ((char *) &rbuf.accessed[0] - (char *) (&rbuf)), outf);	/* 0 ~ level */
		fwrite(&rbuf.tm_year, 1, (sizeof(rbuf) - ((char *) &rbuf.tm_year - (char *) &rbuf)), outf);	/* tm_year ~ dummy */
		fwrite(&rbuf.accessed[0], 1, sizeof(rbuf.accessed), outf);	/* accessed */
		fwrite(empty, 1, 1024, outf);
	    }
	    fclose(outf);
	}
	fclose(inf);
	if (unlink(infname) == -1) 
	    fprintf(stderr, "unlink error: %s\n", infname);;

	if (rename(outfname, infname) == -1) 
	    fprintf(stderr, "rename error: %s --> %s\n", outfname, infname);;
	/*
        { char cmdbuf[500];
        fprintf(stderr, "Moving %s %s\n", outfname, infname);
        sprintf(cmdbuf, "/bin/mv %s %s", outfname, infname);
        system(cmdbuf);
        }
	    */
    }
}
