#!/bin/csh
# IMPORTANT!!!!!!
# Set the values of OLDMAXUSERS and NEWMAXUSERS appropriately or you'll
# destroy your boards and mail. BACK UP EVERYTHING first!!!

# set OLDMAXUSERS=1580
# set NEWMAXUSERS="`expr 1580 + 1024`"
set OLDMAXUSERS=2048
set NEWMAXUSERS="`expr 2048 + 1024`"
set INITDIR="/home/bbsSrc/src"

foreach DIR ( `find $INITDIR/boards -name ".BOARDS" -print` )
    set FILE="$DIR"
    if ( -f "$FILE" && ! -z "$FILE" ) then
        resizeindex $FILE $OLDMAXUSERS $NEWMAXUSERS
        /etc/chown bbs $FILE
    endif
end

foreach DIR ( `find $INITDIR/boards -name ".DIR" -print` )
    set FILE="$DIR"
    if ( -f "$FILE" && ! -z "$FILE" ) then
        resizeindex $FILE $OLDMAXUSERS $NEWMAXUSERS
        /etc/chown bbs $FILE
    endif
end

foreach DIR ( `find $INITDIR/mail -name ".DIR" -print` )
    set FILE="$DIR"
    if ( -f "$FILE" && ! -z "$FILE" ) then
        resizeindex $FILE $OLDMAXUSERS $NEWMAXUSERS
        /etc/chown bbs $FILE
    endif
end

# foreach DIR ( `find $INITDIR/boards -type d -print` )
#     mv -f $DIR/.BOARDS.bak $DIR/.BOARDS
# end
# foreach DIR ( `find $INITDIR/boards -type d -print` )
#     mv -f $DIR/.DIR.bak $DIR/.DIR
# end
# foreach DIR ( `find $INITDIR/mail -type d -print` )
#     mv -f $DIR/.DIR.bak $DIR/.DIR
# end
