#!/bin/csh
# IMPORTANT!!!!!!
# Set the values of OLDMAXUSERS and NEWMAXUSERS appropriately or you'll
# destroy your boards and mail. BACK UP EVERYTHING first!!!

set INITDIR="/home/bbs"
set RECORDSIZE=2048

foreach DIR ( `find $INITDIR/boards -name ".BOARDS" -print` )
    set FILE="$DIR"
    if ( -f "$FILE" && ! -z "$FILE" ) then
        echo "Running rearrange $FILE $RECORDSIZE"
        rearrange $FILE $RECORDSIZE
        # /etc/chown bbs $FILE
    endif
end

foreach DIR ( `find $INITDIR/boards -name ".DIR" -print` )
    set FILE="$DIR"
    if ( -f "$FILE" && ! -z "$FILE" ) then
        echo "Running rearrange $FILE $RECORDSIZE"
        rearrange $FILE $RECORDSIZE
        # /etc/chown bbs $FILE
    endif
end

foreach DIR ( `find $INITDIR/mail -name ".DIR" -print` )
    set FILE="$DIR"
    if ( -f "$FILE" && ! -z "$FILE" ) then
        echo "Running rearrange $FILE $RECORDSIZE"
        rearrange $FILE $RECORDSIZE
        # /etc/chown bbs $FILE
    endif
end
